#ifndef TRACKNODE_HPP__
#define TRACKNODE_HPP__

#include "nodes/base/base.hpp"
#include <opencv2/opencv.hpp>
#include "common/meta.hpp"
#include "common/data.hpp"
#include "BYTETracker.h"
#include "infer/infer.hpp"

namespace GNode
{

class TrackNode : public BaseNode
{
public:
    TrackNode() = delete;
    TrackNode(const std::string& name, std::vector<std::string> track_labels, int frame_rate, int track_buffer) : BaseNode(name, NODE_TYPE::MID_NODE) 
    {
        track_labels_ = track_labels;
        tracker_ = std::make_shared<BYTETracker>(frame_rate, track_buffer);
    }
    virtual ~TrackNode()  { stop(); };
    void work() override;

private:
    std::shared_ptr<BYTETracker> tracker_ = nullptr;
    std::vector<std::string> track_labels_;

};

}

#endif  // TRACKNODE_HPP__